package org.vendor.tftp.common;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import java.net.DatagramPacket;
import java.net.InetAddress;
import org.vendor.tftp.common.TFTPCommon;

public class DataPacket {
  public static final int DATA_OFFSET_ADDRESS = 4;
  
  private InetAddress tftpAddress;
  
  private int packetType = TFTPCommon.PacketType.DATA.ordinal();
  
  private int tftpPort;
  
  private int blockNumber;
  
  private int dataLength;
  
  private int dataOffset = 4;
  
  private byte[] data;
  
  public DataPacket() {
    this.data = new byte[1472];
  }
  
  public DataPacket(DatagramPacket datagram) {
    this.tftpAddress = datagram.getAddress();
    this.tftpPort = datagram.getPort();
    this.data = datagram.getData();
    if (this.data != null && this.data.length >= 4) {
      this.packetType = this.data[1] & 0xFF;
      this.blockNumber = (this.data[2] & 0xFF) << 8 | this.data[3] & 0xFF;
    } 
    this.dataLength = datagram.getLength() - 4;
  }
  
  public DatagramPacket newDatagram(InetAddress tftpAddress, int tftpPort, int blockNumber, byte[] fileData, int dataLength) {
    int datagramPacketLength = dataLength + 4;
    byte[] tftpData = new byte[datagramPacketLength];
    tftpData[0] = 0;
    tftpData[1] = (byte)TFTPCommon.PacketType.DATA.ordinal();
    tftpData[2] = (byte)((blockNumber & 0xFFFF) >> 8);
    tftpData[3] = (byte)(blockNumber & 0xFF);
    System.arraycopy(fileData, 0, tftpData, 4, dataLength);
    return new DatagramPacket(tftpData, datagramPacketLength, tftpAddress, tftpPort);
  }
  
  public static int getBlockNumber(DatagramPacket datagram) {
    byte[] tempData = datagram.getData();
    if (tempData != null && tempData.length >= 4)
      return (tempData[2] & 0xFF) << 8 | tempData[3] & 0xFF; 
    return 0;
  }
  
  public InetAddress getAddress() {
    return this.tftpAddress;
  }
  
  public int getPort() {
    return this.tftpPort;
  }
  
  public int getPacketType() {
    return this.packetType;
  }
  
  public int getBlockNumber() {
    return this.blockNumber;
  }
  
  public byte[] getData() {
    return this.data;
  }
  
  public int getDataLength() {
    return this.dataLength;
  }
  
  public int getDataOffset() {
    return this.dataOffset;
  }
}
